@echo off
echo. 
echo This batch program (C) iQuate Support
echo Make sure iQSonar, IIS and .NET Framework v2 is fully installed.
echo Contact support if you need help.
echo This file and source web.txt must be in iQSonar Root directory.
echo !!!WARNING!!!
echo This batch file assumes that you have installed iQSonar to the
echo default location. (C:\Program Files (x86)\iQuate) and that it is being run
echo from the C:\Program Files (x86)\iQuate folder
echo.

:CHOICE1
          set /P c=Are you sure you want to continue [Y/N]?
          if /I "%c%" EQU "Y" goto :SONAR_CHK
          if /I "%c%" EQU "N" goto :CALL_END
          goto :CHOICE1
		  
:CHOICE2
		echo Web.txt found.
          set /P c=Are you sure you want to Update Sonar Folder Permissions [Y/N]?
          if /I "%c%" EQU "Y" goto :ST_OWNR
          if /I "%c%" EQU "N" goto :CHOICE3
          goto :CHOICE2
		  
:CHOICE3
          set /P c=Are you sure you want to Update IIS [Y/N]?
          if /I "%c%" EQU "Y" goto :IIS_UP
          if /I "%c%" EQU "N" goto :CHOICE4
          goto :CHOICE3
		  
:CHOICE4
          set /P c=Are you sure you want to Update Web.Config [Y/N]?
          if /I "%c%" EQU "Y" goto :WEB_CP
          if /I "%c%" EQU "N" goto :CHOICE5
          goto :CHOICE4
		  
:CHOICE5
          set /P c=Do you want to Encrypt Connection String [Y/N]?
          if /I "%c%" EQU "Y" goto :ENC_STR
          if /I "%c%" EQU "N" goto :CALL_END
          goto :CHOICE5
		  
:SONAR_CHK
		echo Checking if iQSonar is installed
          if exist iQSonar\iQuate.Sonar.Configuration.exe (        
          GOTO :IIS_CHK
          ) 
          goto :SONAR_CHK_NO
		  
:IIS_CHK
		echo iQSonar found.
		echo Checking if IIS appcmd is installed
          if exist %WINDIR%\System32\inetsrv\appCmd.exe (  
          GOTO :WEB_CHK
          ) 
          GOTO :IIS_CHK_NO
		  
:WEB_CHK
		echo IIS found.
		echo Checking if web.txt is present
          if exist web.txt (       
		  GOTO :CHOICE2
		  )
          GOTO :WEB_CHK_NO
		  
:ST_OWNR
		echo Setiing up permissions.
          icacls iQSonar\Sonar /setowner IIS_IUSRS /T
		  icacls iQSonar\Sonar /grant IIS_IUSRS:(OI)(CI)F /T
          GOTO :CHOICE3
		  
:IIS_UP
		echo Setting up IIS
		C:\Windows\System32\inetsrv\appcmd add app /site.name:"Default Web Site" /path:"/iQSonar" /PhysicalPath:"C:\Program Files (x86)\iQuate\iQSonar\Sonar"
		C:\Windows\System32\inetsrv\appcmd add app /site.name:"Default Web Site" /path:"/iQSonar/API" /PhysicalPath:"C:\Program Files (x86)\iQuate\iQSonar\Sonar\API"
		C:\Windows\System32\inetsrv\appcmd add apppool /name:"IQSonar" /managedRuntimeVersion:"v2.0" /ManagedPipelineMode:"Classic" /Enable32BitAppOnWin64:true
		C:\Windows\System32\inetsrv\appcmd set app /app.name:"Default Web Site/iQSonar" /applicationPool:"iQSonar"
		C:\Windows\System32\inetsrv\appcmd set app /app.name:"Default Web Site/iQSonar/API" /applicationPool:"iQSonar"
        GOTO :CHOICE4
		  
:WEB_CP
          set /P c=BACKUP EXISTING WEB.CONFIG? EXISTING BACKUP WILL BE REPLACED! [Y/N]?
          if /I "%c%" EQU "Y" goto :WEB_BU
          if /I "%c%" EQU "N" goto :CP
          goto :WEB_CP
		  
:WEB_BU
		echo Backingup Web.config
          copy iQSonar\Sonar\Web.config iQSonar\Sonar\Web.config.old
		  
:CP
		echo Updating Web.config
          copy /y web.txt iQSonar\Sonar\Web.config
          GOTO :CHOICE5

:ENC_STR
		Encripting Connection string
          %windir%\Microsoft.NET\Framework\v2.0.50727\aspnet_regiis -pe "connectionStrings" -app "/iQSonar"
          GOTO :CALL_END

:SONAR_CHK_NO
          echo Please Check if iQSonar is installed.
          GOTO :CALL_END

:IIS_CHK_NO
          echo Please Check if IIS installed appcmd doesn't exist.
          GOTO :CALL_END

:WEB_CHK_NO
          echo Please Check if WEB.TXT exist.
          GOTO :CALL_END
          
:CALL_END
          echo This batch operation will end now.
          PAUSE
          EXIT